package org.expeditee.auth.account;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.CertificateException;
import java.sql.SQLException;
import java.util.Map;

import javax.crypto.SecretKey;

import org.expeditee.auth.AuthenticatorBrowser;
import org.expeditee.auth.tags.AuthenticationTag;
import org.expeditee.gui.DisplayController;
import org.expeditee.gui.FrameIO;
import org.expeditee.gui.MessageBay;

public class Password {
	/*
	 * Changes the recorded password for a user in the key store.
	 */
	public static void changePassword(final Map<AuthenticationTag, String> userdata) throws NoSuchAlgorithmException, KeyStoreException, FileNotFoundException, CertificateException, IOException, ClassNotFoundException, SQLException {
		final String username = userdata.get(AuthenticationTag.Username);
		final String password = userdata.get(AuthenticationTag.Password);
		final String newpassword = userdata.get(AuthenticationTag.NewPassword);

		final SecretKey key = AuthenticatorBrowser.getInstance().getSecretKey(username, password);
		if (key == null) {
			MessageBay.errorMessage("The username + existing password combination was incorrect.");
		} else {
			AuthenticatorBrowser.getInstance().putKey(username, newpassword, key);
			MessageBay.displayMessage("Password changed successfully.");
			DisplayController.setCurrentFrame(FrameIO.LoadFrame("multiuser1"), true);
		}
	}
}
